#!/bin/bash

module load LUMI/23.03 partition/G PrgEnv-cray/8.3.3 cce/15.0.1 cray-mpich/8.1.25
mpic++ -c -fopenmp -I. -o lumi-g-test.mpi.o lumi-g-test.mpi.cpp
hipcc --offload-arch=gfx90a -c -fopenmp -I. -o stream.hip.o stream.hip.cpp
hipcc --offload-arch=gfx90a -c -fopenmp -I. -o device_affinity.hip.o device_affinity.hip.cpp
hipcc --offload-arch=gfx90a -c -fopenmp -I. -o memcopy.hip.o memcopy.hip.cpp
CC -c -fopenmp -I. -o core_affinity.o core_affinity.cpp
LIB=$(hipconfig --path)/lib
CC -target-accel=amd_gfx90a -fopenmp -o lumi-g-test core_affinity.o lumi-g-test.mpi.o stream.hip.o device_affinity.hip.o memcopy.hip.o -L$LIB -Wl,-rpath=$LIB -lamdhip64

