#include <mpi.h>
#include <iostream>
#include <omp.h>

extern void hip_memcopy(int rank, int stride, int ngpus);
extern int hip_stream(int rank);
extern void core_affinity(int rank);
extern void device_affinity(int rank);

int main(int argc, char **argv)
{
	MPI_Init(&argc, &argv);
	int size, rank;
	MPI_Comm_size(MPI_COMM_WORLD, &size);
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);
	int n = omp_get_max_threads();
	std::cout << ">> rank=" << rank << " nthreads=" << n << std::endl;
	MPI_Barrier(MPI_COMM_WORLD);
#pragma omp parallel 
	{	
		for (int j = 0; j < 1; j++) {
#pragma omp master
			{
				core_affinity(rank);
			}
		}
	}
	MPI_Barrier(MPI_COMM_WORLD);
#pragma omp parallel 
	{	
		for (int j = 0; j < 1; j++) {
#pragma omp master
			{

				device_affinity(rank);

			}
		}
	}
	MPI_Barrier(MPI_COMM_WORLD);
#pragma omp parallel 
	{	
		for (int j = 0; j < 1; j++) {
#pragma omp master
			{
				hip_stream(rank);
			}
		}
	}
	MPI_Barrier(MPI_COMM_WORLD);
	const int ngpus = 8;
	for (int i = 1; i < ngpus * 2; i *= 2) {
#pragma omp parallel 
	{	
		for (int j = 0; j < 1; j++) {
#pragma omp master
			{

				hip_memcopy(rank, i, ngpus);
			}
		}
	}
	MPI_Barrier(MPI_COMM_WORLD);
	}
	MPI_Finalize();
	return 0;
}
